const http = require("http");


class Server {
    constructor(config) {
        this._port = config.port;
        this._hostName = config.hostName;
        this._eventEmitter = config.eventEmitter;
        this._eventListenerName = config.eventListenerName;

    };

    start() {
        http.createServer((req, res) => {
            this._eventEmitter.emit(this._eventListenerName, req, res);
            res.send = sendresponse()
        }).listen(this._port,
            console.log(`Server Online on ${this._hostName} On Port ${this._port}`));
    }
}
function sendresponse() {
    return function(status , statusCode = 200 , message ,data){
        this.statusCode= statusCode;
        this.setHeader("Content-Type" ,"application/json");
        this.end(JSON.stringify({status: status , response : data ? data : message}));
    }
}

module.exports =
    Server